/*->c.mainwin */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "font.h"

#include "wos.h"
#include "err.h"
#include "task.h"
#include "poll.h"
#include "temp.h"
#include "scrap.h"
#include "fsx.h"
#include "conf.h"
#include "etc.h"
#include "flex.h"
#include "deb.h"
#include "appinfo.h"
#include "mlo.h"
#include "osunits.h"
#include "colour.h"
#include "xmath.h"
#include "bf.h"
#include "save.h"
#include "load.h"


#include "resource.h"


#include "constants.h"

#include "reslink.h"


#include "mainwin.h"
#include "gridexport.h"
#include "memblock.h"
#include "dc.h"
#include "spell.h"
#include "soln.h"
#include "grid.h"
#include "main.h"
#include "xstdio.h"

#include "file.h"






typedef struct
{
 char name[24];
 char  mark[8];
 char copy[64];
 char stuff[120];
 int  splitfraction;  // window
 int  width;          // window
 int  height;         // window
 int  minsollen;
 int  drawsolutions;
 int  dmask;
 int  gridtype;
 int  gridcase;
 int  draftfill;
 int  saveupper;
 int  x;              // grid size
 int  y;              // grid size
} gheader;



int saveupper;
int draftfill;
int gridcase;

int filechanged;


os_error * modfile(void)
{
 filechanged++;
 if(filechanged==1) updategridtitle();
 return(NULL);
}


os_error * unmodfile(void)
{
 filechanged=0;
 return(NULL);
}


int filemodded(void)
{
 return(filechanged!=0);
}



static os_error * savegridsub(char * filename)
{
 os_error * err;
 gheader    gh;
 FILE     * fp;
 int        x;
 windowstr  window;

 err=NULL;

 memset(&gh,0,sizeof(gh));

 strcpy(gh.name,"CrossStar Grid");
 strcpy(gh.mark,"1.02");
 strcpy(gh.copy,"(14-Dec-2001)");
 gh.x=maxx;
 gh.y=maxy;
 gh.saveupper=saveupper;
 gh.draftfill=draftfill;
 gh.gridcase=gridcase;
 gh.gridtype=gridtype;
 gh.dmask=dmask;
 gh.drawsolutions=drawsolutions;
 gh.minsollen=minsollen;

 gh.splitfraction=splitfraction;
 getw(mainhandle,&window);
 gh.width=window.x1-window.x0;
 gh.height=window.y1-window.y0;

 fp=fopenex(filename,"wb");
 if(fp)
 {
  fwrite(&gh,sizeof(gheader),1,fp);

  writefhdc(fp);

  for(x=0;x<maxx;x++)
   fwrite(griddata[x],1,maxy,fp);

  for(x=0;x<maxx;x++)
   fwrite(gridstate[x],1,maxy,fp);

  fwrite(&textfont,sizeof(font_description),1,fp);
  fwrite(&cluefont,sizeof(font_description),1,fp);
  fwrite(&textcolour,sizeof(int),1,fp);
  fwrite(&gridcolour,sizeof(int),1,fp);
  fwrite(&fillcolour,sizeof(int),1,fp);
  fwrite(&emptycolour,sizeof(int),1,fp);
  fwrite(&gridmeshratio,sizeof(int),1,fp);

  fclose(fp);
 }

 return(err);
}



os_error * savegrid(char * filename)
{
 os_error * err;

 err=savegridsub(filename);
 if(!err) err=unmodfile();
 if(!err) err=setgridname(filename);

 return(err);
}




os_error * savedefaultgrid(void)
{
 char  uname[MAX_USERNAME];
 char  name[MAX_PATH];

 getusername(uname,sizeof(uname));
 sprintf(name,"%sDefault\\%s.crx",programdir,uname);
 savegridsub(name);
 writedefaultparameters();

 return(NULL);
}



static char savegridpath[MAX_PATH];


int filecansave(void)
{
 return(strlen(savegridpath));
}


os_error * savecurrentgrid(void)
{
 if(!filecansave()) return(geterror(ENOSAVE));
 return(savegrid(savegridpath));
}



os_error * setgridname(char * name)
{
 strcpy(savegridpath,name);
 updategridtitle();
 return(NULL);
}


char * filecurrentname(void)
{
 return(savegridpath);
}




static os_error * csaveoption(int handle,int opt,int * type,char * name,int maxlen)
{
 switch(opt)
 {

  case 0:
         *type=CXFTYPE;
         break;

  case 1:
         *type=EMFTYPE;
         break;

  case 2:
         *type=WMFTYPE;
         break;

  case 3:
         *type=PMFTYPE;
         break;
 }


 return(NULL);
 USE(handle);
 USE(name);
 USE(maxlen);
}




static saveoptionstr saveoptions[]=
{
 "CrossStar grid file (*.crx)",  csaveoption,
 "Enhanced metafile (*.emf)",    csaveoption,
 "Metafile (*.wmf)",             csaveoption,
 "Placeable metafile (*.wmf)",   csaveoption,

};




static int csaveopt;




static os_error * csavefile(char * name,int type)
{
 os_error * err;

 err=NULL;

 switch(type)
 {

   case WMFTYPE:
                err=saveaswmf(name);
                break;

   case PMFTYPE:
                err=saveasplaceablewmf(name);
                break;

   case EMFTYPE:
                err=saveasemf(name);
                break;

   case CXFTYPE:
                err=savegrid(name);
                break;
 }

 return(err);
}




os_error * savegridas(int handle)
{
 os_error * err;
 char       savepath[MAX_PATH];

 setsaveoptions(4,saveoptions,&csaveopt);
 strcpy(savepath,"Grid");
 err=opensaveparent(savepath,NITEM(savepath),CXFTYPE,csavefile,handle);

 return(err);
}



static int newgridtype;


static os_error * loadgridsub(char * filename)
{
 os_error * err;
 gheader    gh;
 FILE     * fp;
 int        x;
 int        y;
 int        mark100;
 int        mark102;


 err=NULL;

 memset(&gh,0,sizeof(gh));

 fp=fopenex(filename,"rb");
 if(fp)
 {
  trashfhdc();

  fread(&gh,sizeof(gheader),1,fp);

  mark100=(strcmp(gh.mark,"1.01")<0);
  mark102=(strcmp(gh.mark,"1.02")>=0);

  maxx=gh.x;
  maxy=gh.y;
  saveupper=gh.saveupper;
  draftfill=gh.draftfill;
  gridcase=gh.gridcase;
  newgridtype=gh.gridtype;
  drawsolutions=gh.drawsolutions;
  minsollen=gh.minsollen;         // should not load this on CrossStar files
  dmask=gh.dmask;
  if(gh.splitfraction) splitfraction=gh.splitfraction;
  loadwidth=gh.width;
  loadheight=gh.height;


  readfhdc(fp);

  for(x=0;x<maxx;x++)
   fread(griddata[x],1,maxy,fp);

  for(x=0;x<maxx;x++)
   fread(gridstate[x],1,maxy,fp);

  for(x=0;x<maxx;x++)
  {
   for(y=0;y<maxy;y++)
   {
    if((gridstate[x][y] & STMASK)==HILITE)
     gridstate[x][y]&=~STMASK;

    if(mark100) gridstate[x][y]&=~(BLOCKX|BLOCKY);
   }
  }

  if(mark102)
  {
   cprintf("text height %d",textfont.height);
   fread(&textfont,sizeof(font_description),1,fp);
      cprintf("text height %d",textfont.height);
   fread(&cluefont,sizeof(font_description),1,fp);
   fread(&textcolour,sizeof(int),1,fp);
   fread(&gridcolour,sizeof(int),1,fp);
   fread(&fillcolour,sizeof(int),1,fp);
   fread(&emptycolour,sizeof(int),1,fp);
   fread(&gridmeshratio,sizeof(int),1,fp);
  }
  else
  {
   readdefaultparameters();
  }

  fclose(fp);

  mapfhdc();

  setparameters();
  setgridextent();
  refreshgrid();
  removezone();
  blanksolutions();
  loadopenwindow();

  removecursor();
 }

 return(err);
}






os_error * loaddefaultgrid(void)
{
 os_error * err;
 char       uname[MAX_USERNAME];
 char       name[MAX_PATH];
 int        type;

 err=getusername(uname,sizeof(uname));
 if(!err)
 {
  sprintf(name,"%sDefault\\%s.crx",programdir,uname);
  fs_exists(name,&type);
  if(type==1)
  {
   err=loadgridsub(name);
   if(!err)
   {
    writedefaultparameters();
   }
   else
   {
    readdefaultparameters();
    setparameters();
   }
  }
  else
  {
   readdefaultparameters();
   setparameters();
  }

  setgridtypeload(newgridtype);
 }
 return(err);
}


int loadwords(char * name)
{
 FILE  * fp;
 int     c;
 char    string[STRLEN];
 int     i;


 fp=fopen(name,"rb");
 if(!fp) return(0);

// hourglasson();
 gridstartredraw();
 clearselection();
 gridendredraw();

 clearsolutions(); 

 while(!feof(fp))
 {
  while(1)
  {
   c=fgetc(fp);
   if(feof(fp) || c>32) break;
  }
  if(feof(fp) && c<=32) break;

  i=0;
  string[i++]=c;

  while(!feof(fp) && i<STRLEN) 
  {
   c=fgetc(fp);
   if(c<32) break;
   if(isalpha(c)) string[i++]=tolower(c);
  } 

  if(i<STRLEN)
  {
   string[i]=0;
   addsquaresolution(-1,-1,-1,-1,string);
  }
 }

 fclose(fp);

// hourglassoff();

 opensol();
 setsolextent();
 refreshsols();

 return(1);
}




os_error *loadgridtypev(char * name,int type,mousestr * m,int userhandle,int * method)
{
 if(type==CXFTYPE || (type==TEXTFILE && (gridtype==SQUARETYPE)))*method=1;
 else                                                           *method=0;

 return(NULL);
 USE(userhandle);
 USE(m);
	USE(name);
}




os_error * loadgridv(char * name,int type,int userhandle,int xvolatile)
{
 os_error  * err;

	if(type==TEXTFILE)
	{
  loadwords(name);
		err=NULL;
	}
	else
	{
  err=loadgridsub(name);
	}

 return(err);
 USE(userhandle);
 USE(type);
 USE(xvolatile);
}



os_error * loadgridpostv(int userhandle)
{
 os_error    * err;

/* dprintf(0,"load doc post"); */

 err=NULL;


 return(err);

 USE(userhandle);
}





os_error * loadgrid(char * name,int type,int userhandle,int xvolatile)
{
 os_error * err;

          err=loadgridv(name,type,0,0);
 if(!err) err=loadgridpostv(0);
 if(!err) err=unmodfile();
 if(!err) err=setgridname(name);
 setgridtypeload(newgridtype);

 return(err);

 USE(userhandle);
 USE(xvolatile);
}






os_error * opengrid(int handle)
{
 os_error * err;
 loadoptstr opts;
 int        xtype=CXFTYPE;
 int        copt;
 char       name[MAX_PATH];

 opts.description="CrossStar grid files (*.crx)";
 opts.ntypes=1;
 opts.types=&xtype;

 strcpy(name,"");

 err=openloadparent(name,&copt,&opts,1,loadgrid,0,handle);


 return(err);
}


